#include<reg52.h>
void first_line();		//Accesing 1st line of 40x4 lcd 
void second_line();		//Accesing 2nd line of 40x4 lcd 
void third_line();		//Accesing 3rd line of 40x4 lcd 
void fourth_line();		//Accesing 4th line of 40x4 lcd 
sbit rw =P3^0;   //Read/Write Pin
sbit en1=P3^1;   //Enable for First 80 Characters
sbit rs =P3^2;   //Register select (RS)
sbit en2=P3^3;   //Enable for Second 80 Characters
sbit LH =P2^3;   // For Latching the Inputs in Latch
sbit OE1=P2^7;	 //Data available on Output Pins
sbit OE2=P2^6;	 //Data available on Output Pins
sbit OE3=P2^5;	 //Data available on Output Pins
sbit OE4=P2^4;	 //Data available on Output Pins
char a[8]={0x04,0x0E,0x15,0x04,0x04,0x04,0x04,0x00};	
char b[8]={0x04,0x04,0x04,0x04,0x15,0x0E,0x04,0x00};
void delay(unsigned int time)  //Time delay function
{
unsigned int i,j;
for(i=0;i<time;i++)
for(j=0;j<5;j++);
}

             //Function for sending values to the command register of LCD
void lcdcmd1(unsigned char value)  
{
P1=value;
rs = 0;
rw = 0;
en1 = 1;             		
delay(10);
en1=0;
delay(10);

}
             //Function for sending values to the command register of LCD
void lcdcmd2(unsigned char value)  
{
P1=value;
rs = 0;
rw = 0;
en2 = 1;             		
delay(10);
en2=0;
delay(10);

}
             //Function for sending values to the data register of LCD
void display1(unsigned char value)  
{
P1=value;
rs = 1;
rw = 0;
en1 = 1;           		
delay(10);
en1=0;
delay(10);

}
             //Function for sending values to the data register of LCD
void display2(unsigned char value)  
{
P1=value;
rs = 1;
rw = 0;
en2 = 1;           		
delay(10);
en2=0;
delay(10);

}
             //function to initialize the registers and pins of LCD
             //always use with every lcd of hitachi
void lcdint1(void)         
{
P1=0x00;                 
P3=0x00;
delay(5000);
display1(0x30);
delay(4500);
display1(0x30);
delay(300);
display1(0x30);
delay(650);
lcdcmd1(0x38);	//Character font = 5x8
delay(50);
lcdcmd1(0x0C);
delay(50);
lcdcmd1(0x01);
delay(50);
lcdcmd1(0x06);
delay(50);
}

void lcdint2(void)         
{
P1=0x00;                 
P3=0x00;
delay(15000);
display2(0x30);
delay(4500);
display2(0x30);
delay(300);
display2(0x30);
delay(650);
lcdcmd2(0x38);		 //Character font = 5x8
delay(50);
lcdcmd2(0x0C);
delay(50);
lcdcmd2(0x06);
delay(50);
lcdcmd2(0x01);
delay(50);
}

void main()
{
unsigned int i=0,dataa=0;
P0=0xFF; //Port-0 as Input
P1=0x00; //Port-1 as Output
P2=0x00; //Port-2 as Output 
P3=0x00; //Port-3 as Output


lcdint1();		  //Initializing first hd44780 lcd controller
lcdint2();		  //Initializing second hd44780 lcd controller

lcdcmd1(0x48);	   //Creating custom character in CG-RAM 
for(i=0;i<8;i++)
display1(a[i]);

lcdcmd2(0x48);	   //Creating custom character in CG-RAM 
for(i=0;i<8;i++)
display2(a[i]);

lcdcmd1(0x50);	   //Creating custom character in CG-RAM 
for(i=0;i<8;i++)
display1(b[i]);

lcdcmd2(0x50);	  //Creating custom character in CG-RAM 
for(i=0;i<8;i++)
display2(b[i]);


first_line();
fourth_line();
second_line();
third_line();
OE1=1;
OE2=1;
OE3=1;
OE4=1;


while(1){
LH=0;
delay(50);
LH=1;	    //High pulse
delay(50);
LH=0;		//Low Pulse
OE1=0;      //Latch data on Output Pins
delay(50);
lcdcmd1(0xD6);	   //Third Latch Setup
for(i=0;i<8;i++)
{
dataa=((P0>>i)& 1);
if(dataa==1)
display1(1);
else
display1(2);	
}				  //Third Latch Setup
OE1=1;
delay(5);
OE2=0;     //Latch data on Output Pins 

lcdcmd1(0xDE);	   //Second Latch Setup
for(i=0;i<8;i++)
{
dataa=((P0>>i)& 1);
if(dataa==1)
display1(1);
else
display1(2);	
}				  //Second Latch Setup
OE2=1;
delay(5);
OE3=0;     //Latch data on Output Pins

lcdcmd2(0x96);	   //Third Latch Setup
for(i=0;i<8;i++)
{
dataa=((P0>>i)& 1);
if(dataa==1)
display2(1);
else
display2(2);	
}				  //Third Latch Setup
OE3=1;
delay(5);
OE4=0;     //Latch data on Output Pins

lcdcmd2(0x9E);	   //Fourth Latch Setup
for(i=0;i<8;i++)
{
dataa=((P0>>i)& 1);
if(dataa==1)
display2(1);
else
display2(2);	
}				  //Fourth Latch Setup
OE4=1;
delay(5);
}
			 
}

void first_line(){
unsigned int count=0;
char st[]=" SMART PLC(Programable Logic Controler)";
lcdcmd1(0x80);
while(st[count]!='\0')
	{
		display1(st[count]);
		count++;	
	}
}

void second_line(){
unsigned int count=0;
char st[]=" Input  Coils Status ";
lcdcmd1(0xC0);
while(st[count]!='\0')
	{
		display1(st[count]);
		count++;	
	}
}

void third_line(){
unsigned int count=0;
char st[]=" Output Coils Status ";
lcdcmd2(0x80);
while(st[count]!='\0')
	{
		display2(st[count]);
		count++;	
	}

}

void fourth_line(){
unsigned int count=0;
char st1[]="I/O Energized";
char st2[]="I/O Denergized";
lcdcmd2(0xC0);
display2(' ');
display2(0x01);
display2(' ');
display2(' ');
display2(0x7E);

while(st1[count]!='\0')
	{
		display2(st1[count]);
		count++;	
	}
count=0;
display2(' ');
display2(' ');
display2(' ');
display2(0x02);
display2(' ');
display2(' ');
display2(0x7E);
while(st2[count]!='\0')
	{
		display2(st2[count]);
		count++;	
	}

}